/*****************************************************************************/
/* EyeClock - A clock application for X. The eyes follow the mouse.          */
/*                                                                           */
/* EyeClock Copyright (c) 1998 Sakai Hiroaki.                                */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* BSD Daemon Copyright 1988 by Marshall Kirk McKusick.                      */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* EyeClock is a simple clock application for X11. You can put an optional   */
/* picture on the face of the clock. And you can move the eyes of the        */
/* picture following the mouse.                                              */
/*                                                                           */
/* EyeClock is a free software. You may copy or distribute the original      */
/* EyeClock freely. But, you may not modify or distribute the original       */
/* EyeClock without permission of the author.                                */
/*                                                                           */
/* Statement on the Use of the BSD Daemon Figure:                            */
/*                                                                           */
/* The BSD Daemon is to be used in the context of BSD software.              */
/* So, if you are using BSD software (BSD/OS, FreeBSD, NetBSD, OpenBSD,      */
/* or BSD utilities) in your Intranet environment, then use of the           */
/* daemon is appropriate. If you are a Microsoft shop, then it is not        */
/* appropriate.                                                              */
/*                                                                           */
/* Individuals may use the daemon for their personal use within the          */
/* bounds of good taste (an example of bad taste was a picture of the        */
/* BSD daemon blowtorching a Solaris logo). When reasonably possible,        */
/* I would like the text ``BSD Daemon Copyright 1988 by Marshall Kirk        */
/* McKusick. All Rights Reserved.'' to be included.  This text need          */
/* not be etched into the figure or garishly displayed when using the        */
/* daemon as say an Icon in a Web window. A good example of how              */
/* to handle the due credit in a web page is to create a link from           */
/* the daemon picture to the following text:                                 */
/*                                                                           */
/*         BSD Daemon Copyright 1988 by Marshall Kirk McKusick.              */
/*         All Rights Reserved.                                              */
/*                                                                           */
/*         Permission to use the daemon may be obtained from:                */
/*                 Marshall Kirk McKusick                                    */
/*                 1614 Oxford St                                            */
/*                 Berkeley, CA 94709-1608                                   */
/*                 USA                                                       */
/*         or via email at mckusick@mckusick.com                             */
/*                                                                           */
/* If you are looking for daemon images, a pictorial history of the          */
/* daemon can be found at http://www.mckusick.com/beastie/index.html.        */
/*                                                                           */
/* If you want to mass produce the daemon on Tshirts, CDROM's, or other      */
/* products you need to request permission in advance. In general, I require */
/* that the daemon be used in an appropriate way. This means that it         */
/* has to be something related to BSD and not expropriated as a company      */
/* logo (though I do allow companies with BSD-based products such as         */
/* Walnut Creek CDROM or BSDI to use it).  I regret having to be so          */
/* legalistic about the daemon, but I almost lost the daemon to a            */
/* certain large company because I failed to show due diligence in           */
/* protecting it. So, I've taken due diligence seriously since then.         */
/*                                                                           */
/*         Marshall Kirk McKusick                                            */
/*****************************************************************************/

/*****************************************************************************/
/* إåΥ󥯥롼                                                      */
/*****************************************************************************/

#include"eyetype.h"

/*****************************************************************************/
/* ʸɤ߹                                                            */
/*****************************************************************************/

int CheckSplitWord(int c)
{
  return ( (c == '\n') || (c == '\t') || (c == ' ') || (c == ',') );
}

int CheckCommentWord(int c)
{
  return ( (c == '#') || (c == '%') || (c == '$') || (c == '!' ) );
}

int CheckLineEnd(int c)
{
  return ( (c == '\n') || (c == EOF) );
}

int CheckQuotationWord(int c)
{
  return ( (c == '\"') || (c == '\'') );
}

int StringPointer(int f)
{
  static int string_pointer = 0;

  if (f == CLEAR) string_pointer = 0;
  if (f == ON) return (string_pointer++);
  return (string_pointer);
}

int GetChar(void * p, int type)
{
  if (type == READ_FROM_STRING) {
    if (StringPointer(OFF) >= strlen((char *)p)) return (EOF);
    else return (((char *)p)[StringPointer(ON)]);
  } else if (type == READ_FROM_FILE) return (fgetc((FILE *)p));
}

int ReadString(void * p, int type, char * string)
{
  int c, i = 0;

  c = GetChar(p, type);
  while (CheckSplitWord(c) || CheckCommentWord(c)) {
    while (CheckSplitWord(c)) c = GetChar(p, type);
    while (CheckCommentWord(c)) while (!CheckLineEnd(c = GetChar(p, type)));
  }
  if (CheckQuotationWord(c))
    while ( (!CheckQuotationWord(c = GetChar(p, type))) && (!CheckLineEnd(c)) )
      string[i++] = (char)c;
  else do {
    string[i++] = (char)c;
    c = GetChar(p, type);
  } while ( (!CheckSplitWord(c)) && (!CheckCommentWord(c)) &&
	    (!CheckLineEnd(c)) );
  while (CheckCommentWord(c)) while (!CheckLineEnd(c = GetChar(p, type)));
  string[i] = '\0';
  return (c);
}

int ReadInt(void * p, int type)
{
  char string[128];
  ReadString(p, type, string);
  return (atoi(string));
}

int ReadFlag(void * p, int type)
{
  char string[128];
  ReadString(p, type, string);
  if (!strcmp(string, "ON")) return(ON);
  else return (OFF);
}

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
